#ifndef _ISP_H_
#define _ISP_H_

void isp_chip_erase ();
void isp_pulse_reset (void);
u8 isp_enable_avr (void);
void isp_out_reset (u8 reset_value);
void isp_out_sck (u8 sck_value);

// read
u8 isp_get_part_info (u8 addr);
u8 isp_read_lock_bits ();
u8 isp_read_fuse_low_bits ();
u8 isp_read_fuse_high_bits ();
u8 isp_read_fuse_ext_bits ();
u8 isp_read_cal_byte (u8 addr);

u8 isp_read_byte_flash (u32 addr);
void isp_read_chunk_flash (u32 addr, u8 * chunk, u8 chunkSize);
u8 isp_read_byte_eeprom (u16 addr);
void isp_read_chunk_eeprom (u16 addr, u8 * chunk, u8 chunkSize);

// write
void isp_write_old_fuse_bits (u8 val);
void isp_write_fuse_low_bits (u8 val);
void isp_write_fuse_high_bits (u8 val);
void isp_write_fuse_ext_bits (u8 val);
void isp_write_lock_bits (u8 bits);

void isp_write_byte_flash (u16 addr, u8 val);
void isp_write_chunk_flash (u16 addr, u8 * chunk, u8 chunkSize);
u8 isp_write_byte_eeprom (u16 addr, u8 val);
u8 isp_write_chunk_eeprom (u16 addr, u8 * chunk, u8 chunkSize);

void isp_write_program_memory_page (u16 page_addr);

#endif
