#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>


FILE *fd1;
FILE *fd2;

#define IMAGE_SIZE (0x4000)

int main (int argc, char ** argv)
{
  int result;
  int i;
  int a;
  unsigned char c;
  unsigned char b[32];

  fd1 = fopen (argv[1], "rb");
  fd2 = fopen (argv[2], "w");
  if (fd1 == NULL)
    {
      printf ("unknown file %s\n", argv[1]);
      fflush (stdout);
      exit (-1);
    }


  fputs("#ifndef _BABY_IMAGE_H_\n",fd2);
  fputs("#define _BABY_IMAGE_H_\n",fd2);
  fputs("\n",fd2);

  fputs("#include <config.h>\n",fd2);
  fputs("#include <turbo/turbo.h>\n",fd2);
  fputs("\n",fd2);

  fputs("static const u8 PROGMEM baby_image[] = {\n  ",fd2);
  a=fgetc(fd1);
  for(i=0;a!=EOF;i++) {
    c=a&0xFF;
    sprintf(b,"%02X",c);
    fputs("0x",fd2);
    fputc(b[0],fd2);
    fputc(b[1],fd2);
    a=fgetc(fd1);
    fputs(", ",fd2);
    if((i%8)==7) {
	fputs("\t//0x",fd2);
	sprintf(b,"%04X (%d)",i-7,i-7);
	fputs(b,fd2);
	fputs("\n  ",fd2);
    }
  }

  fputs("};\n\n",fd2);
  fputs("#endif\n",fd2);

  fclose (fd1);
  fclose (fd2);
}
